

int convert_handle;
int convert_toolbox;
int convert_view;
int convert_centre=1;
int convert_x0;
int convert_y1;



void convert_closetoolboxs(int handle)
{
 close_window(handle);
 delete_window(handle);
 convert_handle=0;
 convert_view=0;
}



// handler for convert window close icon

void convert_closetoolbox(int handle)
{
 convert_closetoolboxs(handle);
 convert_toolbox=0;
}




// display converter, centred first time

void convert_display(void)
{
 display_window(convert_handle,0,convert_centre);
 convert_centre=0;
} 



void convert_open3(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 if(!convert_centre)
 {
  x1+=(convert_x0-x0);
  y0+=(convert_y1-y1);
  x0=convert_x0;
  y1=convert_y1;
 }
 else
 {
  convert_x0=x0;
  convert_y1=y1;
 }

 open_window(h,x0,y0,x1,y1,scx,scy,bh);
}


void convert_open5(int h,int x0,int y0,int x1,int y1,int scx,int scy,int bh)
{
 convert_x0=x0;
 convert_y1=y1;
}




void convert_opentoolbox(int view)
{
 if(view)
 {
  convert_handle=create_windowparent("convert_m",viewhandle(view));

  addwindowhandler(1,convert_handle,"convert_keypress");
  addwindowhandler(2,convert_handle,"convert_closetoolbox");
  addwindowhandler(3,convert_handle,"convert_open3");
  addwindowhandler(5,convert_handle,"convert_open5");
  setwindowflags(convert_handle,8,8);
  convert_view=view;
  convert_display();
  insert_caret(convert_handle,11);
 }
}




void convert_activeview(int user,int view,int gain)
{

 if(gain && convert_toolbox && view!=convert_view)
 {
  convert_opentoolbox(view);
 }

 if(!gain && convert_toolbox && view && view==convert_view)
 {
  convert_closetoolboxs(convert_handle);
 }

}





// deal with 'Converter' menu entry

int convert_entry(int entry,int subcode)
{
 convert_toolbox=!convert_toolbox;
 if(convert_toolbox)
 {
  convert_opentoolbox(activeview());
 }
 else
 {
  convert_closetoolbox(convert_handle);
 }
 return(0);
}


// Tick or un-tick 'Converter' menu entry

int convert_flags(int entry, string &text)
{
 return(convert_toolbox);
}


// handler for Return key in writeable

int convert_keypress(int handle, int icon, int key)
{
 string s;
 int v;

 s = readicon(handle, 11);
 v = stringu(s, -1);

 if(key==13)
 {
  writeicon(handle, 3, ustring(v, 1));
  writeicon(handle, 5, ustring(v, 2));
  writeicon(handle, 7, ustring(v, 3));
  writeicon(handle, 9, ustring(v, 0));
  return(-1);
 }

 return(key);
}




// add 'Converter' option to 'Applets' menu
// create window and add window handlers

void main(void)
{
 script_menu_initialise();
 script_menu_insert("convert_entry","convert_flags","","","{CONVERT_00}");

 addeventhandler(0x215,0,"convert_activeview");
}
